Unit IIS1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTII10_p;

procedure IIS1R(T0 :Real; N :Integer; var T :Array of Real;
                var X :Array of Real; var Y :Array of Real;
                var X2 :Array of Real; var Y2 :Array of Real;
                var X0 :Real; var Y0 :Real; var IERR :Integer);

implementation

procedure IIS1R(T0 :Real; N :Integer; var T :Array of Real;
                var X :Array of Real; var Y :Array of Real;
                var X2 :Array of Real; var Y2 :Array of Real;
                var X0 :Real; var Y0 :Real; var IERR :Integer);
var
K,J,N1 :Integer;
Z1,Z2,Z3 :Real;
A :Array [0..7] of Real;
F :Array [0..1] of Real;
label
_1,_2,_3,_4,_5;
begin
IERR := 0;
N1 := N-1;
for K:=1 to N1 do
 begin
  J := K+1;
  Z1 := T0-T[J-1];
  if ( Z1 <= 0.0 ) 
   then goto _2;
_1:
 end;
IERR := 65;
UTII10(IERR,1);
goto _5;
_2:
Z1 := T[J-1]-T[K-1];
Z2 := 1.0/(6.0*Z1);
Z3 := 1.0/6.0*Z1;
A[0] := Z2*(X2[J-1]-X2[K-1]);
A[4] := Z2*(Y2[J-1]-Y2[K-1]);
A[1] := 0.5*X2[K-1];
A[5] := 0.5*Y2[K-1];
A[2] := (X[J-1]-X[K-1])/Z1-Z3*(X2[J-1]+2.0*X2[K-1]);
A[6] := (Y[J-1]-Y[K-1])/Z1-Z3*(Y2[J-1]+2.0*Y2[K-1]);
A[3] := X[K-1];
A[7] := Y[K-1];
Z1 := T0-T[K-1];
for J:=1 to 2 do
 begin
  Z2 := A[0+(J-1)*4];
  for K:=2 to 4 do
   begin
    Z2 := Z2*Z1+A[(K-1)+(J-1)*4];
_3:
   end;
  F[J-1] := Z2;
_4:
 end;
X0 := F[0];
Y0 := F[1];
_5:
end;

end.
